REM File: Dndsic5 for Dndbbs Version v5.0a Release r2.0

' get include files
REM $INCLUDE: 'DNDSIC.INC'

REM $DYNAMIC
DEFINT A-Z

' playwav constants
CONST PlayBuffer = 32767
DIM SHARED SpeakerVolume AS INTEGER

' playwav variables
COMMON SHARED BasePort%
COMMON SHARED Channel%
COMMON SHARED WavBuffer() AS STRING * PlayBuffer

REM Plays .wav files for blind or sight impaired people.

REM Dmaplay.bas code was adapted from Dma.zip written by Mike Huff (1996).
REM Which was modified by Martin Rampersad.
REM And was rewritten into Playwav.bas,
REM Program downloaded from http://www.ocf.berkeley.edu/~horie

SUB Playwav(Tmp1,Tmp1$)
 On Local Error Goto Play.Error

 ' select .wav file
 If Tmp1>0 Then
 Select Case Tmp1
 Case 1
    Tmp1$="Laser.wav"
 Case 2
    Tmp1$="Ringin.wav"
 Case 3
    Tmp1$="Carrier.wav"
 Case 4
    Tmp1$="Boing.wav"
 Case 5
    Tmp1$="Bang.wav"
 Case 6
    Tmp1$="Connect.wav"
 Case 7
    Tmp1$="Complete.wav"
 Case 8
    Tmp1$="Gunshot.wav"
 Case 9
    Tmp1$="Ricochet.wav"
 Case 10 ' a
    Tmp1$="Whoosh.wav"
 Case 11 ' b
    Tmp1$="Glass.wav"
 Case 12 ' c
    Tmp1$="Cashreg.wav"
 Case Else
    Error 92
    Exit Sub
 End Select
 Endif

 ' locate file
 IF Tmp1$ = Nul THEN
    EXIT SUB
 END IF
 Tmp2$ = Tmp1$
 IF DIR$(Tmp2$) = Nul THEN
    EXIT SUB
 END IF

 ' Parse BLASTER environment variable
 Call GetBLASTER
 If BasePort% = 0% Then
    Error 92
    Exit Sub
 Endif

 ' reopen input file
 X = FREEFILE
 IF X = 0 THEN
    EXIT SUB
 END IF
 OPEN Tmp2$ FOR BINARY AS #X

 ' create buffer for file.
 REDIM WavBuffer(1 TO 1) AS STRING * PlayBuffer

 ' turn on speaker and adjust volume.
 Call AdjustVolume(SpeakerVolume)

 ' get buffer from file skipping header.
 GET #X, 44, WavBuffer(1)

 ' store memory address of sound buffer.
 Segment& = VARSEG(WavBuffer(1))
 Offset& = VARPTR(WavBuffer(1))

 ' store length of sound file minus header.
 Length& = LOF(X) - 44

 ' Adjust length if needed to 32k
 IF Length& > 32767 THEN Length& = 32767

 ' call the sound buffer player.
 CALL DMAPlay(Segment&, Offset&, Length&)

 Close #X
 Erase WavBuffer
 EXIT SUB
Play.Resume:
 Exit Sub
Play.Error:
 Resume Play.Resume
END SUB

' plays the contents of the buffer.
SUB DMAPlay(Segment&, Offset&, Length&)
 Freq& = 10000
 Length& = Length& - 1
 Page% = 0
 MemLoc& = Segment& * 16 + Offset&
 SELECT CASE Channel%
 CASE 0
    PgPort% = &H87
    AddPort% = &H0
    LenPort% = &H1
    ModeReg% = &H48
 CASE 1
    PgPort% = &H83
    AddPort% = &H2
    LenPort% = &H3
    ModeReg% = &H49
 CASE 2
    PgPort% = &H81
    AddPort% = &H4
    LenPort% = &H5
    ModeReg% = &H4A
 CASE 3
    PgPort% = &H82
    AddPort% = &H6
    LenPort% = &H7
    ModeReg% = &H4B
 CASE ELSE
    EXIT SUB
 END SELECT
 OUT &HA, &H4 + Channel%
 OUT &HC, &H0
 OUT &HB, ModeReg%
 OUT AddPort%, MemLoc& AND &HFF
 OUT AddPort%,(MemLoc& AND &HFFFF&) \ &H100
 IF MemLoc& AND 65536 THEN
    Page% = Page% + 1
 END IF
 IF MemLoc& AND 131072 THEN
    Page% = Page% + 2
 END IF
 IF MemLoc& AND 262144 THEN
    Page% = Page% + 4
 END IF
 IF MemLoc& AND 524288 THEN
    Page% = Page% + 8
 END IF
 OUT PgPort%, Page%
 OUT LenPort%, Length& AND &HFF
 OUT LenPort%, (Length& AND &HFFFF&) \ &H100
 OUT &HA, Channel%

 TimeConst% = 256 - 1000000 \ Freq&
 V% = &H40
 Call WriteDSP(V%)

 V% = TimeConst%
 Call WriteDSP(V%)

 V% = &H14
 Call WriteDSP(V%)

 V% = Cint(Length& AND &HFF)
 Call WriteDSP(V%)

 V% = Cint((Length& AND &HFFFF&) \ &H100)
 Call WriteDSP(V%)
END SUB

' parse the BLASTER environment string and return settings.
SUB GetBlaster
 REM SET BLASTER=A220 I5 D1 H5 P330 T3 V9
 Var$ = Environ$("BLASTER")
 IF Var$ = Nul THEN ' default values
    BasePort% = &H220
    Channel% = &H1
    SpeakerVolume = 13
    EXIT SUB
 END IF
 Var% = INSTR(Var$, "A") ' base IO port
 If Var% Then ' A220
    BasePort% = VAL("&H" + MID$(Var$, Var% + 1, 3))
 Endif
 Var% = INSTR(Var$, "D") ' 8-bit DMA channel
 If Var% Then ' D1
    Channel% = VAL(MID$(Var$, Var% + 1, 1))
 Endif
 SpeakerVolume=13
 Var% = INSTR(Var$, "V") ' speaker volume
 If Var% Then ' V1
    SpeakerVolume = VAL(MID$(Var$, Var% + 1))
 Endif
 Var$ = Environ$("BLASTERVOLUME")
 IF Len(Var$) THEN ' default volume
    SpeakerVolume=Int(Val(Var$))
 Endif
END SUB

' turn on speaker and adjust volume.
SUB AdjustVolume(Loudness%)
 ' Turn on speaker.
 V% = &HD1
 Call WriteDSP(V%)
 ' Adjust the volume.
 V% = Loudness% + Loudness% * 16 ' right/left
 OUT BasePort% + 4, &H22
 OUT BasePort% + 5, V% AND &HFF
END SUB

' writes a byte to the DSP (digital signal processor)
SUB WriteDSP(byte2%)
 DO: LOOP WHILE INP(BasePort% + 12) AND &H80
 OUT BasePort% + 12, byte2%
END SUB
